#if defined _mm_const_included
  #endinput
#endif
#define _mm_const_included

#if AMXX_VERSION_NUM < 183
  #define client_print_color ColorChat
  #define print_team_default NORMAL
  #define print_team_grey GREY
  #define print_team_red RED
  #define print_team_blue BLUE
  #define print_team_green GREEN
  #include <colorchat>

  #define Ham_CS_Player_ResetMaxSpeed Ham_Item_PreFrame
  #define DMG_GRENADE (1<<24)
  stock HamHook:RegisterHamPlayer(Ham:function, const Callback[], Post=0)
    return RegisterHam(function, "player", Callback, Post);

  #if defined _fakemeta_included
    #define write_coord_f(%0) engfunc(EngFunc_WriteCoord, %0)
    stock message_begin_f(dest, msg_type, const Float:origin[3] = {0.0,0.0,0.0}, player=0)
      engfunc(EngFunc_MessageBegin, dest, msg_type, origin, player);
  #endif
#endif

#define MM_VERSION "1.1.2"
#define MM_AUTHOR  "GuskiS"
#define MM_TAG      "^3[^4MurderMod^3]^1"

#define MM_KNIFE_THROW "mm_knife_throw"
#define MM_DEAD_BODY   "mm_dead_body"

#define MM_MAXNAMES      26
#define MM_MAXFILELENGHT 64
#define MM_SETTINGSFILE  "murdermod.ini"
#define MM_CONFIGFILE    "murdermod.cfg"

#pragma semicolon 1

enum _:CLASS
{
  CLASS_NONE,
  CLASS_BYSTANDER,
  CLASS_MURDERER,
  CLASS_ARMED,
  CLASS_DEAD
}

enum _:PLAYERDATA
{
  PD_CLASS,     // CLASS
  PD_CANTPICK,  // Can player pick weapon?
  PD_NATO,      // Name from name list
  PD_SHOWKNIFE, // Should shown knife to others?
  PD_COLOR,     // Color
  PD_SMOKETIME, // Time until smoke appears
  PD_KILLED,    // Killed by
  PD_STARTCLASS // Initial class (at round start)
}

enum _:GAMEMODE
{
  GAME_UNSET,
  GAME_PREPARING,
  GAME_RESTARTING,
  GAME_STARTED,
  GAME_ENDED
}
