#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <murdermod>

new Float:g_fKickDelay[33], cvar_damage_entities;

public plugin_precache()
{
  precache_sound("murdermod/cbar_hitbod2.wav");
}

public plugin_init()
{
  register_plugin("[MM] Destroy breakables", MM_VERSION, MM_AUTHOR);
  register_forward(FM_EmitSound, "Forward_EmitSound");
  cvar_damage_entities = my_register_cvar("mm_damage_entities", "25.0", "Damage dealth to breakable objects. (Default: 25.0)");
}

public Forward_EmitSound(id, channel, sample[])
{
  if(!is_user_connected(id))
    return FMRES_IGNORED;
  if(equal(sample, "common/wpn_denyselect.wav"))
  {
    if(get_user_weapon(id) == CSW_KNIFE && !mm_get_playerdata(id, PD_SHOWKNIFE) && g_fKickDelay[id] < get_gametime())
    {
      new ent, body;
      get_user_aiming(id, ent, body, 50);
      if(is_valid_ent(ent) && entity_get_float(ent, EV_FL_health))
      {
        static classname[32];
        entity_get_string(ent, EV_SZ_classname, classname, charsmax(classname));
        if(equal(classname, "func_breakable"))
        {
          g_fKickDelay[id] = get_gametime() + 0.7;
          used_use(id, ent);
          return FMRES_IGNORED;
        }
      }
    }
  }

  return FMRES_IGNORED;
}

public used_use(id, ent)
{
  if(!is_user_alive(id) || !is_valid_ent(ent))
    return;

  emit_sound(id, CHAN_AUTO, "murdermod/cbar_hitbod2.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
  UTIL_PlayWeaponAnimation(id, 4);
  ExecuteHamB(Ham_TakeDamage, ent, id, id, get_pcvar_float(cvar_damage_entities), 0);
}
