#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <murdermod>

public plugin_init()
{
  register_plugin("[MM] Pickup from distance", MM_VERSION, MM_AUTHOR);
  register_forward(FM_EmitSound, "Forward_EmitSound");
}

public Forward_EmitSound(id, channel, sample[])
{
  if(!is_user_connected(id) || mm_get_playerdata(id, PD_CANTPICK))
    return FMRES_IGNORED;

  if(equal(sample, "common/wpn_denyselect.wav"))
  {
    static origin[3], classname[32], Float:forigin[3];
    get_user_origin(id, origin, 3);
    IVecFVec(origin, forigin);

    new ent = -1;
    while((ent = engfunc(EngFunc_FindEntityInSphere, ent, forigin, 10.0)))
    {
      if(entity_range(id, ent) < 70.0)
      {
        entity_get_string(ent, EV_SZ_classname, classname, charsmax(classname));
        if(equal(classname, "weaponbox"))
        {
          if(mm_get_playerdata(id, PD_CLASS) != CLASS_MURDERER)
          {
            fake_touch(ent, id);
            break;
          }
        }
        else if(equal(classname, MM_KNIFE_THROW))
        {
          if(mm_get_playerdata(id, PD_CLASS) == CLASS_MURDERER)
          {
            mm_set_playerdata(id, PD_SHOWKNIFE, 1);
            mm_give_knife(id, ent);
            break;
          }
        }
      }
    }
  }

  return FMRES_IGNORED;
}
